/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.15.0
        Device            :  PIC18F46K80
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc_generated_files/mcc.h"
#include "../APP001_LCD_XC8/APP001V3_LCD.H"
#include "../AN738_XC8/PIC18FXXK80_ECAN_Mode0.h"

void     User_T1_ISR(void) ;
void     openCAN(void) ;
void     loadDataToCAN(void) ;

#define			MESSAGE_ID1			0x100
#define			RX_FILTER0			0x400
#define			RX_FILTER1			0x000	
#define			RX_FILTER2			0x000
#define			RX_FILTER3			0x000
#define			RX_FILTER4			0x000
#define			RX_FILTER5			0x000
#define			RXB0_MASK			0x7ff
#define			RXB1_MASK			0x7ff

	unsigned long	TX_ID ;
	unsigned char	TX_Data_Buf1[8] ;

	unsigned long	RXBn_ID ;
	unsigned char	RXBn_Data_Buf[8] ;
	unsigned char	RXBn_Data_Len	;
	enum 			CAN_RX_MSG_FLAGS	RXBn_Message_Flag ; 	
    
union
	{
		unsigned char	Bytes[2] ;
		unsigned int	Word ;	
	}   AD_ALL ;    

union
{
    struct
    {
        unsigned TIMER1_FLAG : 1 ;
        unsigned TIMER2_FLAG : 1 ;
        unsigned CAN_DATA_AVAILABLE : 1 ;
        unsigned :5 ;
    }; 
    unsigned char   ByteValue ;
}FlagReg1;

unsigned int    ADC_Value ;

/*
                         Main application
 */
void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
    openCAN() ;

    FlagReg1.ByteValue = 0 ;
    // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global and Peripheral Interrupts
    // Use the following macros to:

    // Enable high priority global interrupts
    INTERRUPT_GlobalInterruptHighEnable();

    // Enable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowEnable();

    // Disable high priority global interrupts
    //INTERRUPT_GlobalInterruptHighDisable();

    // Disable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowDisable();

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    openLCD();
    setCursorLCD(0,0);
    putrsLCD("OID=     OA=") ;
    setCursorLCD(0,1) ;
    putrsLCD("IID=     IA=") ;
    
    while (1)
    {

 		if ( CANIsRxReady( ) )

		{
			CANReceiveMessage(&RXBn_ID,RXBn_Data_Buf,&RXBn_Data_Len,&RXBn_Message_Flag ) ;

				AD_ALL.Bytes[1] = RXBn_Data_Buf[7] ;		// ADRESH
				AD_ALL.Bytes[0] = RXBn_Data_Buf[6] ;		// ADRESL
				
                setCursorLCD(12,1);
                putNumberLCD(AD_ALL.Word,4) ;
                
                setCursorLCD(4,1);
                putHexIntLCD( (unsigned int)RXBn_ID);
                
		}       
        
        if (FlagReg1.TIMER1_FLAG)
        {       
            ADC_Value = ADC_GetConversion(VR1_AN0) ;
            setCursorLCD(12,0) ;
            putNumberLCD(ADC_Value,4) ;  
            FlagReg1.TIMER1_FLAG = 0 ;
            
            loadDataToCAN();
            CANSendMessage(	MESSAGE_ID1 ,TX_Data_Buf1,8,CAN_TX_PRIORITY_0 &
                            CAN_TX_STD_FRAME &
                            CAN_TX_NO_RTR_FRAME ) ;   
            setCursorLCD(4,0);
            putHexIntLCD( MESSAGE_ID1);
        }
        // Add your application code
    }
}

void     User_T1_ISR(void)
{
    D9_LED_Toggle();
    FlagReg1.TIMER1_FLAG = 1 ;
}

void    loadDataToCAN(void)
{
	TX_Data_Buf1[0] = 0x01 ;
	TX_Data_Buf1[1] = 0x02 ;
	TX_Data_Buf1[2] = 0x03 ;
	TX_Data_Buf1[3] = 0x04 ;
	TX_Data_Buf1[4] = 0x05 ;    
    TX_Data_Buf1[5] = 0x06 ; 
	TX_Data_Buf1[6] = (ADC_Value % 256) ;    // ADC Low Byte 
	TX_Data_Buf1[7] = (ADC_Value/256) ;      // ADC High Byte 
}

void    openCAN(void)
{
 /*
 * Function:        void CANInitialize( BYTE SJW,
 *                                      BYTE BRP,
 *                                      BYTE PHSEG1,
 *                                      BYTE PHSEG2,
 *                                      BYTE PROPSEG,
 *                                      enum CAN_CONFIG_FLAGS flags) 
 */
    
	CANInitialize(    4,4,8,5,2,	CAN_CONFIG_LINE_FILTER_OFF & 
									CAN_CONFIG_SAMPLE_ONCE & 
									CAN_CONFIG_VALID_STD_MSG &
									CAN_CONFIG_PHSEG2_PRG_ON ) ;

	CANSetOperationMode(CAN_OP_MODE_CONFIG) ;

	CANSetMask(CAN_MASK_B1, RXB0_MASK, CAN_CONFIG_STD_MSG ) ;	// Set Mask For Standard Data Frame 
	CANSetMask(CAN_MASK_B2, RXB1_MASK, CAN_CONFIG_STD_MSG ) ;
	
	CANSetFilter(CAN_FILTER_B1_F1, RX_FILTER0  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B1_F2, RX_FILTER1  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F1, RX_FILTER2 , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F2, RX_FILTER3  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F3, RX_FILTER4  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F4, RX_FILTER5  , CAN_CONFIG_STD_MSG) ;

//	CANSetOperationMode(CAN_OP_MODE_NORMAL) ;
	//Adam
	CANSetOperationMode(CAN_OP_MODE_NORMAL) ;    
}

/**
 End of File
*/