/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.15.0
        Device            :  PIC18F46K80
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set SW2_RB0 aliases
#define SW2_RB0_TRIS               TRISB0
#define SW2_RB0_LAT                LATB0
#define SW2_RB0_PORT               RB0
#define SW2_RB0_WPU                WPUB0
#define SW2_RB0_ANS                ANSEL10
#define SW2_RB0_SetHigh()    do { LATB0 = 1; } while(0)
#define SW2_RB0_SetLow()   do { LATB0 = 0; } while(0)
#define SW2_RB0_Toggle()   do { LATB0 = ~LATB0; } while(0)
#define SW2_RB0_GetValue()         PORTBbits.RB0
#define SW2_RB0_SetDigitalInput()    do { TRISB0 = 1; } while(0)
#define SW2_RB0_SetDigitalOutput()   do { TRISB0 = 0; } while(0)

#define SW2_RB0_SetPullup()    do { WPUB0 = 1; } while(0)
#define SW2_RB0_ResetPullup()   do { WPUB0 = 0; } while(0)
#define SW2_RB0_SetAnalogMode()   do { ANSEL10 = 1; } while(0)
#define SW2_RB0_SetDigitalMode()   do { ANSEL10 = 0; } while(0)


// get/set D9_LED aliases
#define D9_LED_TRIS               TRISC1
#define D9_LED_LAT                LATC1
#define D9_LED_PORT               RC1
#define D9_LED_SetHigh()    do { LATC1 = 1; } while(0)
#define D9_LED_SetLow()   do { LATC1 = 0; } while(0)
#define D9_LED_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define D9_LED_GetValue()         PORTCbits.RC1
#define D9_LED_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define D9_LED_SetDigitalOutput()   do { TRISC1 = 0; } while(0)




/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
*/